module Network.HTTP.Pony.Serve.Wai.Type where


import Data.ByteString (ByteString)
import Data.CaseInsensitive (CI)
import Network.Socket (Socket)
import Pipes (Producer)

type StartLine = ByteString
type Header = (CI ByteString, ByteString)

type Message a m r = (StartLine, [Header], Producer a m r)

type Request a m r = Message a m r
type Response a m r = Message a m r

-- App shouldn't block!
type Application m a b c d = Request a m c -> m (Response b m d)
type App = Application IO ByteString ByteString () ()
